/*
** File Name : panel.cpp
**
**     User Interface Generator Library For TC++
**     ~    ~         ~
**     Copyright (c) 1990,1991 M.Takayanagi (SSC Co.,Ltd.)
**
**			PANEL CLASS
**                      ~~~~~~~~~~~
*/

#include <stdio.h>
#include <string.h>
#include <process.h>
#include <stdlib.h>
#include <ctype.h>
#include <dir.h>
#include <dos.h>
#include "uiglib.h"

/*
** plĩRXgN^
*/
PANEL_PARTS::PANEL_PARTS(int l, int c, unsigned int a, char* b,
                         FENCE fe, unsigned int fa, int f)
{
	line		= l;
	column		= c;
	attribute	= a;
	buffer		= b;
	fence		= fe;
	fence_attribute = fa;
	flags		= f;
}

/*
** plĩfXgN^
*/
PANEL_PARTS::~PANEL_PARTS()
{
	;
}

/*
** pli̕\
*/
void	PANEL_PARTS::display(PANEL& p)
{
	p.locate(line, column);
	p.color(attribute);
	p.puts(buffer);
	if (fence==FENCE0) {
		p.locate(line, column-1);
		p.color(fence_attribute);
		p.puts("[");
		p.locate(line, column+strlen(buffer));
		p.color(fence_attribute);
		p.puts("]");
	} else if (fence==FRAME0) {
		p.box(line-1, column-1, 3, strlen(buffer)+2, fence_attribute);
	}
}

/*
** pli̒Ƀ}EXJ[\邩ǂ`FbNB
*/
int	PANEL_PARTS::mouse_check(PANEL& p)
{
	int	clk = 0;
	int	l, c, ll, lc;
	p.stat(l, c, ll, lc);
	int	mx, my;
	p.mouse_position(mx, my);
	int x = column+c-2;
	int y = line+l-2;
	p.mouse_position(mx, my);
	int length = strlen(buffer);
	if ((x*8<=mx && mx<= (x+length)*8)&&(y*16<=my && my<=(y+1)*16)) {
		clk = 1;
	}
	return(clk);
}

/*
**@ɓ삷镔iǂ`FbN
*/
int	PANEL_PARTS::active(PANEL& p)
{
	int	atv = 0;
	if (p.event_type() == BUTTON_PRESSED) {
		int	left, right;
		p.mouse_button(left, right);
		if (left) {
			atv = mouse_check(p);
		}
	}
	return(atv);
}

/*
** i̓
*/
int	PANEL_PARTS::activate(PANEL& p)
{
	return(PANEL_RESUME);
}

/*
** bZ[W̃RXgN^
*/
MESSAGE::MESSAGE(int l, int c, unsigned int a, char *b, 
                                FENCE fe, unsigned int fa):
	 PANEL_PARTS(l, c, a, b, fe, fa, 0)
{
	return;
}

/*
** bZ[W̃fXgN^
*/
MESSAGE::~MESSAGE(void)
{
	return;
}

/*
** {^̃RXgN^
*/
BUTTON::BUTTON(int l, int c, unsigned int a, char *b, unsigned int k,  
               FENCE fe,unsigned int fa, char* func):
        PANEL_PARTS(l, c, a, b, fe, fa, CAN_ACTION)
{
	func_name = func;
	key = k;
	return;
}

/*
** {^̃fXgN^
*/
BUTTON::~BUTTON(void)
{
	return;
}

/*
** {^̓`FbN
*/
int	BUTTON::active(PANEL& p)
{
	int	atv = PANEL_PARTS::active(p);
	if (atv == 0) {
		if (p.event_type()==KEY_PRESSED) {
			unsigned int k = p.key_code();
			if ('a'<=k && k<='z') {
				k = toupper(k);
			}
			if (k==key) {
				atv = 1;
			}
		}
	}
	return(atv);
}

/*
** {^̓
*/
int	BUTTON::activate(PANEL& p)
{
	int	ret = PANEL_RESUME;
	printf("\007");
	if (func_name) {
		ret = p.function(func_name);
	}
	return(ret);
}

/*
** ͍ڂ̃RXgN^
*/
INPUT::INPUT(int l, int c, unsigned int a, char *b, FENCE fe, 
		unsigned int fa, char* func):
		PANEL_PARTS(l, c, a, b, fe, fa, CAN_ACTION|CAN_POINT)
{
	func_name = func;
	return;
}

/*
** ͍ڂ̃fXgN^
*/
INPUT::~INPUT(void)
{
	return;
}

/*
** ͂̓
*/
int	INPUT::activate(PANEL& p)
{
	p.locate(line,column);
	p.color(ATTR_REVERSE|ATTR_YELLOW);
	p.edit(buffer);
	p.locate(line,column);
	p.color(attribute);
	p.puts(buffer);
	int ret = PANEL_CONTINUE;
	if (func_name) {
		ret = p.function(func_name);
	}
	return(ret);
}

/*
** Iڂ͓̓
*/
SELECT::SELECT(int l, int c, unsigned int a, char *b, 
               FENCE fe, unsigned int fa, char* func):
	       PANEL_PARTS(l, c, a, b, fe, fa, CAN_ACTION|CAN_POINT)
{
	func_name = func;
	return;
}

/*
** Iڂ̃fXgN^
*/
SELECT::~SELECT(void)
{
	return;
}

/*
** Iڂ̓
*/
int	SELECT::activate(PANEL& p)
{
	p.locate(line,column);
	p.color(ATTR_REVERSE|ATTR_YELLOW);
	p.puts(buffer);
	p.event_wait();
	p.locate(line,column);
	p.color(attribute);
	p.puts(buffer);
	int ret = PANEL_CONTINUE;
	if (func_name) {
		ret = p.function(func_name);
	}
	return(ret);
}

/*
** PARTS_ARRAY ̃RXgN^
*/
PARTS_ARRAY::PARTS_ARRAY()
{
	array = NULL;
}

/*
** APNEL_ARRAY ̃fXgN^
*/
PARTS_ARRAY::~PARTS_ARRAY()
{
	if (array) {
		delete	array;
	}
}

/*
** z̃AP[V
*/
void	PARTS_ARRAY::allocate(int s)
{
	size = s;
	array = new PANEL_PARTS*[size];
	if (array == 0) {
		fprintf(stderr, "܂B\n");
		exit(1);
	}
}

/*
** z̎Q
*/
PANEL_PARTS*&	PARTS_ARRAY::operator [](int l)
{
	if (l >= size) {
		fprintf(stderr, "i܂B\n");
		exit(1);
	}
	return(array[l]);
}

/*
** pl̃RXgN^
*/
PANEL::PANEL(int l, int c, int ll, int lc, FENCE fe, unsigned int fa, int mp):
       TEXT_WINDOW(l,c,ll,lc)
{
	max_parts = mp;
	next_parts = 0;
	button_exit = 0;
	button_list = 0;
	nparts = active_no = 0;
	fence = fe;
	fence_attribute = fa;
	parts.allocate(mp);
}

/*
** pl̃fXgN^
*/
PANEL::~PANEL()
{
	for (int i=0;i<nparts;i++) {
		delete parts[i];
	}
}

/*
**  ̓obt@̃NA
*/
void	PANEL::clear_buffer()
{
	;
}

/*
**  @\ďo
*/
int	PANEL::function(char* func)
{
	return(PANEL_RESUME);
}


/*
** pl̃I[v
*/
void	PANEL::open()
{
	clear_buffer();
	TEXT_WINDOW::open();
	display();
}

/*
** pl̕\
*/
void	PANEL::display()
{
	if (fence==FRAME0) frame(fence_attribute);
	for (int i=0;i<nparts;i++) {
		parts[i]->display(*this);
	}
}

/*
** o`mdk̃Xebv삲ƂɌĂ΂
*/
int	PANEL::step()
{
	return(PANEL_CONTINUE);
}

/*
** pl̓
*/
int	PANEL::activate()
{
	int	ret;
	int	act = 0;
	for (int i=0;i<nparts;i++) {
		if (parts[i]->can_action()) {
			act = 1;
		}
	}
	if (act == 0) {			// \ȍڂȌꍇ
		event_wait();
		return(PANEL_EXIT);
	}
	active_no=-1;
	for (i=0;i<nparts;i++) {
		if (parts[i]->can_point()) {
			active_no = i;
			break;
		}
	}
	active_no_save = active_no;
	while (1) {
		if (active_no == -1) {	//͍ڂꍇ
			event_wait();
			ret = PANEL_CONTINUE;
		} else {
			ret = parts[active_no]->activate(*this);
		}
		if (ret >= PANEL_EXIT) {	// Iwꍇ
			break;
		}
		if (ret == PANEL_CONTINUE) { // pwꍇ
			active_no_save = active_no;
			int	flg = 1;
			for (i=0;i<nparts;i++) {
				if (parts[i]->active(*this)) {
					active_no = i;
					flg = 0;
					break;
				}
			}
			if (flg) {
				if (event_type()==KEY_PRESSED) {
					int atv = arrow_key(ret);
					if (ret >= PANEL_EXIT) {
						break;
					}
					if (atv >= 0) {
						active_no = atv;
					}
				}
			}
		} else {
			active_no = active_no_save;
		}
		if (next_parts) {
			active_no_save = active_no;
			for (i=0;i<nparts;i++) {
				if (next_parts==parts[i]) {
					active_no = i;
					break;
				}
			}
			next_parts = 0;
		}
		if (step()>=PANEL_EXIT) {
			break;
		}
	}
	event_clear();
	return(ret);
}

/*
** ɓ삷镔i̋w
*/
void	PANEL::set_active_parts(PANEL_PARTS* pp)
{
	next_parts = pp;
}

/*
** L[̓
*/
int	PANEL::left_arrow_key(int& ret)
{
	int	parts_no = -1;
	int	l0, c0, tl, tc;
	int	t, tt, t0;
	parts[active_no]->position(l0, c0);
	t0 = l0*80 + c0;
	t = 0;
	for (int i=0;i<nparts;i++) {
		if (parts[i]->can_point()) {
			parts[i]->position(tl, tc);
			tt = tl*80+tc;
			if (tt<t0 && t<tt) {
				t = tt;
				parts_no = i;
			}
		}
	}
	if (parts_no == -1) {
		ret = left_scroll();
	} else {
		int	l1, c1;
		parts[parts_no]->position(l1, c1);
		if (l1 != l0) {
			ret = left_scroll();
		}
	}
	return(parts_no);
}

/*
** EL[̓
*/
int	PANEL::right_arrow_key(int& ret)
{
	int	parts_no = -1;
	int	l0, c0, tl, tc;
	int	t, tt, t0;
	parts[active_no]->position(l0, c0);
	t0 = l0*80 + c0;
	t = 32767;
	for (int i=0;i<nparts;i++) {
		if (parts[i]->can_point()) {
			parts[i]->position(tl, tc);
			tt = tl*80+tc;
			if (tt>t0 && tt<t) {
				t = tt;
				parts_no = i;
			}
		}
	}
	if (parts_no == -1) {
		ret = right_scroll();
	} else {
		int	l1, c1;
		parts[parts_no]->position(l1, c1);
		if (l1 != l0) {
			ret = right_scroll();
		}
	}
	return(parts_no);
}

/*
** ΂߂͍ڂ̌
*/
int PANEL::near_search(PARTS_ARRAY& pp, int l, int c)
{
	int	parts_no = -1;
	int	d = 256;
	for (int i=0;i<nparts;i++) {
		if (pp[i]->can_point()) {
			int	ll, cc;
			pp[i]->position(ll, cc);
			if (ll == l && abs(cc-c)<d) {
				d = abs(cc-c);
				parts_no = i;
			}
		}
	}
	return(parts_no);
}

/*
** L[̓
*/
int	PANEL::up_arrow_key(int& ret)
{
	int	cline, ccolumn;
	parts[active_no]->position(cline, ccolumn);
	int	l = -1;
	int	parts_no = -1;
	for (int i=0;i<nparts;i++) {
		if (parts[i]->can_point()) {
			int	ll, cc;
			parts[i]->position(ll, cc);
			if (ll < cline && ll > l) {
				l = ll;
			}
		}
	}
	if (l >= 0) {
		parts_no = near_search(parts, l, ccolumn);
	} else {
		ret = up_scroll();
	}
	return(parts_no);
}

/*
** L[̓
*/
int	PANEL::down_arrow_key(int& ret)
{
	int	cline, ccolumn;
	parts[active_no]->position(cline, ccolumn);
	int	l = 256;
	int	parts_no = -1;
	for (int i=0;i<nparts;i++) {
		if (parts[i]->can_point()) {
			int	ll, cc;
			parts[i]->position(ll, cc);
			if (ll > cline && ll < l) {
				l = ll;
			}
		}
	}
	if (l < 256) {
		parts_no = near_search(parts, l, ccolumn);
	} else {
		ret = down_scroll();
	}
	return(parts_no);
}

/*
** L[̓
*/
int	PANEL::arrow_key(int& ret)
{
	int	parts_no = -1;
	int	key = key_code();
	if (key == KEY_RIGHT || key == KEY_CR) {
		parts_no = right_arrow_key(ret);
	} else if (key == KEY_LEFT) {
		parts_no = left_arrow_key(ret);
	} else if (key == KEY_UP) {
		parts_no = up_arrow_key(ret);
	} else if (key == KEY_DOWN) {
		parts_no = down_arrow_key(ret);
	}
	if (parts_no<0) {
		parts_no = active_no;
	}
	return(parts_no);
}

/*
** XN[̏
*/
int	PANEL::up_scroll(void)
{
	return(PANEL_CONTINUE);
}

/*
** XN[̏
*/
int	PANEL::down_scroll(void)
{
	return(PANEL_CONTINUE);
}

/*
** XN[̏
*/
int	PANEL::left_scroll(void)
{
	return(PANEL_CONTINUE);
}

/*
** EXN[̏
*/
int	PANEL::right_scroll(void)
{
	return(PANEL_CONTINUE);
}

// end of file
