#include <stdio.h>
#include <string.h>
#include <dir.h>
#include <dos.h>
#include "uiglib.h"


class PANEL_SMPL : public PANEL {
	INPUT	*str;
	char	buf_str[44];
	INPUT_CHAR	*ch;
	char	buf_ch[2];
	INPUT_INT	*int2;
	char	buf_int2[7];
	INPUT_LONG	*int4;
	char	buf_int4[8];
	INPUT_DOUBLE	*dbl;
	char	buf_dbl[7];
	INPUT_FNAME	*fname;
	char	buf_fname[45];
	INPUT_CHAR	*yn;
	char	buf_yn[2];
public:
	PANEL_SMPL(void);
	virtual void clear_buffer(void);
	virtual int  function(char* func);
	void	     save(void);
};


PANEL_SMPL::PANEL_SMPL():
PANEL(6,12,10,55,FRAME0,ATTR_CYAN)
{
	parts[nparts++] = new MESSAGE(2,2,ATTR_WHITE,":",NOTHING,ATTR_CYAN);
	parts[nparts++] = str = new INPUT(2,10,ATTR_WHITE,buf_str,FENCE0,ATTR_CYAN);
	parts[nparts++] = new MESSAGE(3,2,ATTR_WHITE,":",NOTHING,ATTR_CYAN);
	parts[nparts++] = ch = new INPUT_CHAR(3,10,ATTR_WHITE,buf_ch,"ABCDEFG",FENCE0,ATTR_CYAN);
	parts[nparts++] = new MESSAGE(4,11,ATTR_WHITE,"",NOTHING,ATTR_CYAN);
	parts[nparts++] = new MESSAGE(4,18,ATTR_WHITE,"4޲Đ",NOTHING,ATTR_CYAN);
	parts[nparts++] = new MESSAGE(4,31,ATTR_WHITE,"",NOTHING,ATTR_CYAN);
	parts[nparts++] = new MESSAGE(5,2,ATTR_WHITE,"l:",NOTHING,ATTR_CYAN);
	parts[nparts++] = int2 = new INPUT_INT(5,10,ATTR_WHITE,buf_int2,INT_MIN,INT_MAX,FENCE0,ATTR_CYAN);
	parts[nparts++] = int4 = new INPUT_LONG(5,19,ATTR_WHITE,buf_int4,LONG_MIN,LONG_MAX,FENCE0,ATTR_CYAN);
	parts[nparts++] = dbl = new INPUT_DOUBLE(5,30,ATTR_WHITE,buf_dbl,"%6.2f",0.0,999.99,FENCE0,ATTR_CYAN);
	parts[nparts++] = new MESSAGE(6,2,ATTR_WHITE,"̧ٖ:",NOTHING,ATTR_CYAN);
	parts[nparts++] = fname = new INPUT_FNAME(6,10,ATTR_WHITE,buf_fname,0,"*.*",0,0,FENCE0,ATTR_CYAN);
	parts[nparts++] = new MESSAGE(7,2,ATTR_WHITE,"Yes/No:",NOTHING,ATTR_CYAN);
	parts[nparts++] = yn = new INPUT_CHAR(7,10,ATTR_WHITE,buf_yn,"ynYN",FENCE0,ATTR_CYAN);
	parts[nparts++] = new BUTTON_PUT_STRING(7,15,ATTR_WHITE,"Y:Yes",0,yn,"Y",NOTHING,ATTR_CYAN);
	parts[nparts++] = new BUTTON_PUT_STRING(7,21,ATTR_WHITE,"N:No",0,yn,"N",NOTHING,ATTR_CYAN);
	parts[nparts++] = button_list = new BUTTON(9,29,ATTR_GREEN,"F1:ꗗ",KEY_PF1,FRAME0,ATTR_CYAN,"");
	parts[nparts++] = new BUTTON(9,38,ATTR_GREEN,"F2:ۑ",KEY_PF2,FRAME0,ATTR_CYAN,"save");
	parts[nparts++] = button_exit = new BUTTON_EXIT(9,47,ATTR_GREEN,"ESC:I",KEY_ESC,FRAME0,ATTR_CYAN);
}


void	PANEL_SMPL::clear_buffer()
{
	strcpy(buf_str, "                                           ");
	strcpy(buf_ch, "A");
	strcpy(buf_int2, "     0");
	strcpy(buf_int4, "      0");
	strcpy(buf_dbl, "  0.00");
	strcpy(buf_fname, "                                            ");
	strcpy(buf_yn, "Y");
}


int PANEL_SMPL::function(char* func)
{
	int	ret = PANEL_RESUME;
	if(strcmp(func,"save")==0) {
		save();
	}
	return(ret);
}

void PANEL_SMPL::save()
{
	FILE	*fp;

	fp = fopen("smpl.dat", "w");
	if (fp==NULL) {
		return;
	}
	fprintf(fp, "%s\n", buf_str);
	fprintf(fp, "%s\n", buf_ch);
	fprintf(fp, "%s\n", buf_int2);
	fprintf(fp, "%s\n", buf_int4);
	fprintf(fp, "%s\n", buf_dbl);
	fprintf(fp, "%s\n", buf_fname);
	fprintf(fp, "%s\n", buf_yn);
	fclose(fp);
}

int main()
{
	PANEL_SMPL	p;
	p.open();
	p.activate();
	p.close();
	return(0);
}
