/*
** File Name : tv.cpp
**
**     User Interface Generator Library For TC++
**     ~    ~         ~
**     Copyright (c) 1990,1991 M.Takayanagi (SSC Co.,Ltd.)
**
**			TEXT_VIEW CLASS
**                      ~~~~~~~~~~~~~~~
*/

#include <stdio.h>
#include <string.h>
#include <process.h>
#include <dir.h>
#include <dos.h>
#include <jctype.h>
#include "uiglib.h"


/*
** Iڂ̓
*/
int	TV_LINE::activate(PANEL& p)
{
	TEXT_VIEW* pp = (TEXT_VIEW *)&p;
	if (pp->current_parts()-pp->select_start >= pp->text_lines()) {
		return(PANEL_RESUME);
	}
	return(SELECT::activate(p));
}

/*
**  TEXT_VIEW ̺ݽ׸
*/
TEXT_VIEW::TEXT_VIEW(int l, int c, int ll, int lc, char *fname, int m):
	    PANEL(l, c, ll, lc, FRAME0), TEXT_BUFFER(fname, lc-2)
{
	mode = m;
	strcpy(filename, fname);
	set_parts(ll,lc);
}

TEXT_VIEW::TEXT_VIEW(int l, int c, int ll, int lc, char *b, int bs, int m):
	    PANEL(l, c, ll, lc, FRAME0), TEXT_BUFFER(b, bs, lc-2)
{
	mode = m;
	strcpy(filename, "");
	set_parts(ll,lc);
}

/*
** i̐ݒ
*/
void	TEXT_VIEW::set_parts(int ll, int lc)
{
	fname_size = 0;
	width  = lc-2;
	height = ll-4;
	select_start = nparts;
	for (int i=0;i<height;i++) {
		line_buffer[i] = new char[width+1];
		if (line_buffer[i]==0) {
			fprintf(stderr, "TEXT_VIEW::set_parts:܂\n");
			exit(1);
		}
		if (mode==TV_VIEW) {
			parts[nparts] = new MESSAGE(i+2, 2, ATTR_WHITE, line_buffer[i]);
		} else {
			parts[nparts] = new TV_LINE(i+2, 2, ATTR_WHITE, line_buffer[i]);
		}
		if (i==0) top = parts[nparts];
		if (i==height-1) btm = parts[nparts];
		nparts++;
	}
	if (mode == TV_VIEW) {
		if (strcmp(filename,"")!=0) {
			fname_size = lc-40;
			parts[nparts++] = new MESSAGE(ll-1, 3, ATTR_GREEN, fname_buf, FENCE0);
		}
		parts[nparts++] = new BUTTON(ll-1,lc-35,ATTR_GREEN,  "RUP:߰", KEY_RUP, FRAME0, ATTR_CYAN, "rollup");
		parts[nparts++] = new BUTTON(ll-1,lc-22,ATTR_GREEN, "RDWN:O߰", KEY_RDOWN, FRAME0, ATTR_CYAN, "rolldown");
		parts[nparts++] = button_exit = 
			  new BUTTON_QUIT(ll-1,lc-8,ATTR_GREEN, "ESC:I", KEY_ESC, FRAME0);
	} else {
		if (strcmp(filename,"")!=0) {
			fname_size = lc-49;
			parts[nparts++] = new MESSAGE(ll-1, 3, ATTR_GREEN, fname_buf, FENCE0);
		}
		parts[nparts++] = new BUTTON(ll-1,lc-44,ATTR_GREEN, "RUP:߰", KEY_RUP, FRAME0, ATTR_CYAN, "rollup");
		parts[nparts++] = new BUTTON(ll-1,lc-31,ATTR_GREEN, "RDWN:O߰", KEY_RDOWN, FRAME0, ATTR_CYAN, "rolldown");
		parts[nparts++] = new BUTTON_QUIT(ll-1,lc-17,ATTR_GREEN, "CR:I", KEY_CR, FRAME0, ATTR_CYAN, 1);
		parts[nparts++] = button_exit = 
			  new BUTTON_QUIT(ll-1,lc-8,ATTR_GREEN, "ESC:f", KEY_ESC, FRAME0);
	}
}

/*
**  TEXT_VIEW ޽׸
*/
TEXT_VIEW::~TEXT_VIEW()
{
	for (int i=0;i<height;i++) {
		delete line_buffer[i];
	}
}

/*
** ޯ̧ ر
*/
void	TEXT_VIEW::clear_buffer()
{
	char frm[80];
	sprintf(frm, "%%-%d.%ds", fname_size, fname_size);
	sprintf(fname_buf, frm, filename);
	for (int i=0;i<height;i++) {
		memset(line_buffer[i], ' ', width);
		line_buffer[i][width] = '\0';
	}
	line_ptr = 0;
	set_buffer();
}

int	TEXT_VIEW::function(char* func)
{
	int ret = PANEL_RESUME;
	if (strcmp(func, "rollup")==0) {
		next_page();
	} else if (strcmp(func, "rolldown")==0) {
		prev_page();
	}
	return(ret);
}

/*
**  ÷ޯ̧̓eүޯ̧ɏ
*/
void	TEXT_VIEW::set_buffer()
{
	if (error()) {
		return;
	}
	for (int i=0;i<height;i++) {
		if (line_ptr+i < text_lines()) {
			get_line(line_ptr+i, line_buffer[i]);
		} else {
			memset(line_buffer[i], ' ',  width);
			line_buffer[i][width] = '\0';
		}
	}
}

/*
** @ ۰
*/
int	TEXT_VIEW::up_scroll()
{
	if (line_ptr>0) {
		line_ptr --;
		set_buffer();
		rolldown(2, 2, height, width);
		top->display(*this);
	}
	return(PANEL_CONTINUE);
}

/*
** @@۰
*/
int	TEXT_VIEW::down_scroll()
{
	if (line_ptr+height < text_lines()) {
		line_ptr++;
		set_buffer();
		rollup(2, 2, height, width);
		btm->display(*this);
	}
	return(PANEL_CONTINUE);
}

/*
** @O߰ ݂̓
*/
void	TEXT_VIEW::prev_page()
{
	if (line_ptr>0) {
		line_ptr -= height;
		if (line_ptr<0) line_ptr = 0;
		set_buffer();
		display();
	}
}

/*
** @߰ ݂̓
*/
void	TEXT_VIEW::next_page()
{
	line_ptr += height;
	if (line_ptr+height >= text_lines()) {
		line_ptr = text_lines()-height;
	}
	set_buffer();
	display();
}

/*
** TEXT_VIEW ̓
*/
int	TEXT_VIEW::activate()
{
	int	ret = 0;
	if (error()) {
		POPWIN_WAIT *p = new POPWIN_WAIT(10, 5, "t@CI[vł܂B");
		p->open();
		p->activate();
		p->close();
	} else {
		ret = PANEL::activate();
	}
	return(ret);
}

/*
** Is
*/
int	TEXT_VIEW::selected_line()
{
	int	ret = line_ptr+before_parts()-select_start;
	return(ret);
}

// end of file
