/*----------------------------------------------------------------------*/
/*																		*/
/*								vobmu								*/
/*																		*/
/*		pt@CeLXgt@Cϊ[eBeB		*/
/*																		*/
/*									by									*/
/*																		*/
/*		BohYoh Shibata(Dept.of Chem.Eng., Kyushu Univ.,Fukuoka)			*/
/*																		*/
/*----------------------------------------------------------------------*/

#include	<stdio.h>
#if defined(LATTICE)
	#include	<kanji.h>
#else
	#include	<jctype.h>
#endif

#define		hi(x)	( ((x) >> 8) & 0xFF)	/* ʃoCg */
#define		lo(x)	( (x) & 0xFF)			/* ʃoCg */

FILE	*src;		/* ϊt@C */
FILE	*dst;		/* ϊt@C */

#if defined(LATTICE)||(__ZTC__)

	int putw(unsigned int w, FILE *stream)
	{
		fwrite(&w, sizeof(w), 1, stream);
	}

	int getw(FILE *stream)
	{
		unsigned int ch;
		
		fread(&ch, sizeof(ch), 1, stream);
		return(ch);
	}

#endif

#if defined(__POWERC)

	unsigned short jistojms(unsigned short code)
	{
		register unsigned short	High, Low , h;

		High = hi(code);
		Low  = lo(code);

		h = (High - 1) / 2;
		Low += (High & 0x01) ? 0x1f : 0x7d;
		if (Low >= 0x7f) ++Low;
		High = h + ((h < 0x2e) ? 0x71 : 0xb1);
		return((High << 8) | Low);
	}

#endif

/*----- ʃoCg^ʃoCg -----*/
void swap(unsigned int *x)
{
	*x = ((*x & 0xFF) << 8) | ((*x >> 8) & 0xFF);
}

/*----- ꕶo -----*/
int put(unsigned int ch)
{
	switch (ch) {
	 case 0x000C : putw(0x0a0c , dst); return(0);
	 case 0x000D : putw(0x0a0d , dst); return(0);
	 case 0x0707 : fputc(0x1a , dst);  return(-1);
	}
	if (hi(ch) < 0x20) {
		fputc(lo(ch) , dst);
		return(hi(ch));
	}
	if ((lo(ch) & 0x80) != 0)
		ch &= 0xFF7F;
	ch = jistojms(ch);
	swap(&ch);
    putw(ch , dst);
	return(0);
}

/*----- ϊC -----*/
void QUEENtoTEXT(void)
{
	unsigned int	ch , old = 0xFFFF;
	unsigned char	count;

	fseek(src, 0x06, SEEK_SET);
	ch = getc(src);
	fseek(src, ch+16, SEEK_SET);
	while (1) {
		ch = getw(src);
		if (feof(src)) break;
		if (ch != old) {
			if (put(ch) == -1) break;
		} else {
			count = getc(src);
			while (--count)
				put(ch);
		}
		old = ch;
	}
}

/*-----  -----*/
int initialize(int argc, char *argv[])
{
	if (argc < 2) {
		puts("WPCONV pueeneLXgt@Cϊ[eBeB");
		puts("\tVer.1.1 Copyright 1988-1991 by BohYoh Shibata\n");
		puts("WPCONV SourceFileName [DestinationFileName]");
		puts("\tSourceFileName        ϊt@C");
		puts("\tDesitinationFileName  ϊt@CiȗCONj");
		return(0);
	}
	if ((src = fopen(argv[1] , "rb")) == NULL) {
		printf("t@C%sI[vł܂\n", argv[1]);
		return(0);
	}
	if ((dst = fopen((argc > 2) ? argv[2] : "con", "w")) == NULL) {
		fclose(src);
		puts("o̓t@CI[vł܂");
		return(0);
	}
	return(1);
}

/*----- I -----*/
void ending(void)
{
	fclose(src);
	fclose(dst);
}

/*----- C֐ -----*/
int main(int argc, char *argv[])
{
	if (initialize(argc, argv)) {
		QUEENtoTEXT();
		ending();
	}
	return(0);
}
