EIF	equ	0		;0:jikki 1:emulation

	include	sys.h
;	include biosw.h
	include cddrv.h
 if EIF
	include	porteif.h
 else
	include	port.h
 endif

	public	_ca_open
	public	_ca_sync
	public	_scsists

baseflg	equ	$2273

	zextrn	_al,_bl,_bh,_cl,_ch,_dl
;--------------------------------------------------------------------
	seg	sseg

;====================================================================
;	_CA_OPEN
;
;	in	_cl = rec H
;		_ch = rec M
;		_dl = rec L
;
;		_dh = destination type
;		      0:16M 1:ADPCM
;
;		_bl = destination buff adr L
;		_bh = destination buff adr H
;
;		_al = rec len
;
;	out	ccf=1 :BUS BUSY
;		ccf=0 :OPEN OK
;
_ca_open:
		lda	_dh
		sta	dest_type
		bne	_ca_adpcm
;;---set 16M port
;;---
		bra	ca_open_go

_ca_adpcm:	tst	#%0000_0011,P_TRCTL	;ADTR1,ADTR0 == 1 ?
		beq	ca_open_go
		sec				;ADPCM BUSY ERROR
		bra	ca_open_e

ca_open_go:	lda	#COM_READ		;COMMAND CODE
		sta	cmdtbl
		jsr	addbaserec		;add base address
		lda	_cl
		sta	cmdtbl+1		;source LOG.BLK NO H
		lda	_ch
		sta	cmdtbl+2		;source LOG.BLK NO M
		lda	_dl
		sta	cmdtbl+3		;source LOG.BLK NO L
		lda	_al
		sta	cmdtbl+4		;trans record length
		stz	cmdtbl+5		;must set 0
		lda	_bl			;destination adr L
		sta	ca_adr_l
		lda	_bh			;destination adr H
		sta	ca_adr_h

		stz	cmdptr
		lda	#1
		sta	phase_mon
		clc
ca_open_e:	rts


cmdtbl:		ds	10			;CDB table
cmdptr:		ds	1			;CDB output pointer
phase_mon:	ds	1			;phase monitor
ca_adr_l:	ds	1			;destination adr L
ca_adr_h:	ds	1			;destination adr H
_scsibus:	ds	1			;scsi bus info
_scsists:	ds	1			;scsi status
dest_type:	ds	1			;destination adr type
;====================================================================
;	_CA_SYNC
;
;		out	acc = phase monitor
;				0:not active
;				1:selection
;				2:command out
;				3:data in
;				4:status in
;
;			ccf = 1:closed
;
_ca_sync:
		lda	phase_mon
		beq	ca_sync_e		;NOT ACTIVE

		cmp	#1			;SELECTION
		bne	ca_sync_com
		bsr	ca_select
		bra	ca_sync_e

ca_sync_com:	cmp	#2			;COMMAND OUT
		bne	ca_sync_dat
		bsr	ca_comout
		bra	ca_sync_e

ca_sync_dat:	cmp	#3			;DATA IN
		bne	ca_sync_stat
		jsr	ca_read_go
		bra	ca_sync_e

ca_sync_stat:	cmp	#4			;STATUS IN
		bne	ca_sync_e
		jsr	ca_close		;if ccf=1 trans finished!
		rts

ca_sync_e:	clc
		rts

;====================================================================
;	1:CA_SELECT	selection phase
;
;		out	phase_mon = 2 (if selection ok)
;
ca_select:
		lda	#$81		;SCSI_ID
		sta	P_CMD		;out SCSI ID No.

select:		tst	#S_BSY,P_SCSI	;BSY = 1 ?
		beq	selok
		
selbsy:		sta	P_SEL		;write to SEL_REG

wait30ms:	ldx	#149		;wait 30msec
w30b:		lda	#237		;2	
w30a:		dec	a		;2	238*6-2 +2
		bne	w30a		;4	
		nop			;2	+1428
		nop			;2	+1430
		nop			;2	+1432
		dex			;2	+1434
		bne	w30b		;4	+1436  => 1440

		lda	#$ff
		sta	P_CMD
		tst	#S_REQ,P_SCSI	;REQ = 1 ?
		beq	ca_select
selbsy0:	jsr	acksub		;ACKON REQCHK ACKOFF
selbsy1:	tst	#S_REQ,P_SCSI	;REQ = 1 ?
		bne	selbsy0
		tst	#S_BSY,P_SCSI	;BSY = 1 ?
		bne	selbsy1
		bra	ca_select

selok:		sta	P_SEL		;write to SEL_REG
		clx			;start 20msec TIMER
selokb:		lda	P_SCSI		;5	REQ = 1 ?
		and	#S_REQ		;2
		bne	selend		;2	Selection phase End
		lda	#90		;2(11)
selokc:		dec	a		;2
		bne	selokc		;4(6*91-2+13)
		nop			;2
		dex			;2
		bne	selokb		;4
		bra	ca_select	;	Selection phase Restart

selend:		lda	#2		;selection ok next command out
		sta	phase_mon
		rts
;
;====================================================================
;	2:CA_COMOUT	(S_BSY + S_REQ +         S_CXD        )
;
;	in	(cmdtbl) = command data. length 6 or 10
;		(cmdptr) = command data index
;
;	out	areg, _scsibus = next phase
;
;		S_BSY + S_REQ +         S_CXD         = command out
;		S_BSY + S_REQ +                       = data out
;		S_BSY + S_REQ +                 S_IXO = data in
;		S_BSY + S_REQ +         S_CXD + S_IXO = status in
;		S_BSY + S_REQ + S_MSG + S_CXD         = msg out
;		S_BSY + S_REQ + S_MSG + S_CXD + S_IXO = msg in
;
;		carry = 0:command out ok
;			1:bus busy (can not out command)
;
ca_comout:
		lda	P_SCSI					;5
		and	#(S_BSY+S_REQ+S_MSG+S_CXD+S_IXO)	;2
		sta	_scsibus				;5
		cmp	#(S_BSY+S_REQ+      S_CXD      )	;2 command out?
		beq	comok					;2
		and	#(S_BSY+      S_MSG+S_CXD+S_IXO)	;2
		cmp	#(S_BSY+            S_CXD+S_IXO)	;2 status in ?
		beq	cmdend_s				;2
		cmp	#(S_BSY+                  S_IXO)	;2 data in ?
		beq	cmdend_i				;2
		rts
;
comok:		ldx	cmdptr
		inc	cmdptr
		lda	cmdtbl,x
		sta	P_CMD			;cmd byte write
		nop				;2*4*0.139 (MIN 1micro sec)
		nop
		nop
		nop
		jmp	acksub			;ACKON REQCHK ACKOFF
;
cmdend_i:	lda	#3			;DATA IN
		bra	cmdend
cmdend_s:	lda	#4			;STATUS IN
cmdend:		sta	phase_mon
		rts

;====================================================================
;	3:CA_READ_GO
;			out phase_mon = 4
;
ca_read_go:
		lda	dest_type
		bne	ca_read_adpcm

		lda	P_SCSI
		and	#(S_BSY+S_REQ+S_MSG+S_CXD+S_IXO)
		sta	_scsibus
		cmp	#(S_BSY+S_REQ+            S_IXO)	;data in ?
		beq	ca_read_16m
		cmp	#(S_BSY+S_REQ+      S_CXD+S_IXO)	;status in ?
		jeq	ca_read_end
;		beq	ca_read_end
		rts

CDTEST	equ	1

ca_read_16m:
	lda	ramdram
	bne	ca_read_ram

 if CDTEST
	clx
ca_read_16m_shi_lp:
	lda	P_DREG
	sta	ZDB0			;16m data port
	nop
	nop
	nop
	nop
	dex
	bne	ca_read_16m_shi_lp
	bra	ca_read_ok
 else
	clx
ca_read_16m_shi_lp:
	lda	P_DATA
	sta	ZDB0			;16m data port
	jsr	acksub			;ACKON REQCHK ACKOFF
	dex
	bne	ca_read_16m_shi_lp
	bra	ca_read_ok
 endif
ca_read_ram:
	phy
	cly
	lda	ZBA0L
	sta	_bl
	lda	ZBA0M
	sta	_bh
	lda	ZBA0H
	jsr	dbnkset

ca_read_ram_lp:
	lda	P_DREG
	sta	[_bx],y
	nop
	nop
	nop
	iny
	bne	ca_read_ram_lp
	ply
ca_read_ok:
		rts
;
ca_read_adpcm:
		lda	ca_adr_l		;ADPCM buff adrress L
		sta	P_ADL
		lda	ca_adr_h		;ADPCM buff adrress H
		sta	P_ADH
						;set write counter
		lda	#%0000_0011		;WRITELD,LCD ON
		tsb	P_ADCTL
		lda	#%0000_0001		;WRITELDC OFF
		trb	P_ADCTL
		lda	#%0000_0010		;WRITELD OFF
		trb	P_ADCTL

		lda	#%0000_0010		;ADTR1 = 1, ADTR0 = 0
		sta	P_TRCTL			;all data trans to adpcm
ca_read_end:	lda	#4
		sta	phase_mon
		rts
;====================================================================
;	4:CA_CLOSE
;
;	STATUS	(S_BSY + S_REQ +         S_CXD + S_IXO)
;	MESSAGE	(S_BSY + S_REQ + S_MSG + S_CXD + S_IXO)
;
;	out
;		carry = 1:status in ok	(phase_mon = 0)
;			0:not status in phase
;
;		acc, _scsists = (if ccf == 1) status
;			0:good
;			2:check condition
;
ca_close:
		lda	P_SCSI
		and	#(S_BSY+S_REQ+S_MSG+S_CXD+S_IXO)
		sta	_scsibus
		cmp	#(S_BSY+S_REQ+      S_CXD+S_IXO)	;status in ?
		bne	notstat
;
		stz	P_TRCTL					;ADTR1 = 0, ADTR0 = 0

statok:		lda	P_DATA					;GET STATUS BYTE
		sta	_scsists

		jsr	ackon					;ACK ON
streqchk:	tst	#S_REQ,P_SCSI				;REQ = 1 ?
		bne	streqchk
		jsr	ackoff					;ACK OFF
;
;------ MESSAGE PHASE -----------------------------------------------
meslp1:		lda	P_SCSI
		and	#(S_BSY+S_REQ+S_MSG+S_CXD+S_IXO)
		sta	_scsibus
		cmp	#(S_BSY+S_REQ+S_MSG+S_CXD+S_IXO)	;message in ?
		bne	meslp1
;
mesok:		lda	P_DATA					;GET MESSAGE BYTE
		sta	_scsibus				;already 0

		jsr	ackon					;ACK ON

msreqchk:	tst	#S_REQ,P_SCSI				;REQ = 1 ?
		bne	msreqchk
		jsr	ackoff					;ACK OFF

mesolp:		tst	#S_BSY,P_SCSI				;BUS FREE ?
		bne	mesolp
		stz	phase_mon				;read no active
		sec
		lda	_scsists				;return STATUS BYTE
		rts
;
notstat:	clc
		rts
;====================================================================
;	ACKSUB
;
acksub:
		bsr	ackon
reqchk:		tst	#S_REQ,P_SCSI	;REQ = 1 ?
		bne	reqchk
;
ackoff:		lda	#%1000_0000
		trb	P_INTCTL	;ACK OFF
		rts
;
ackon:		lda	#%1000_0000
		tsb	P_INTCTL	;ACK ON
		rts
;====================================================================
;	ADDBASEREC	in	baseflg	0:1st	1:2nd
;			in/out	_cl = REC H
;				_ch = REC M
;				_dl = REC L
;
addbaserec:
		lda	baseflg
		asl	a
		clc
		adc	baseflg
		tay
		lda	_dl		;rec low
		clc
		adc	recbase0_l,y
		sta	_dl
		lda	_ch		;rec middle
		adc	recbase0_m,y
		sta	_ch
		lda	_cl		;rec high
		adc	recbase0_h,y
		sta	_cl
		rts
;********************************************************************
