;==============================================================================
;    PC-engine constant Header 
;------------------------------------------------------------------------------
;<< common file in Alfa System >>
;      Ver 1.00  1989-02-01
; modify  Apr. 21, 1989  Double 7up, Priority controler
;=============================================================================
l=0
h=1
;-----------------------------------------------------------------------------
;	assember CPU select
;-----------------------------------------------------------------------------
	cpu	'6280'
;-----------------------------------------------------------------------------
;	stack access displasement
;-----------------------------------------------------------------------------
	extrn	STACK
;-----------------------------------------------------------------------------
;       C6270(7UP) port address define
;-----------------------------------------------------------------------------
	extrn	RG7UP		;R/W select 7up register
	extrn	LO7UP		;R/W low byte to 7up
	extrn	HI7UP		;R/W high byte to 7up
;----------------------------------------------------------------------------;
;       HuC6202 Priority controler
;----------------------------------------------------------------------------;
	extrn	PATTY_PRR	; priority register
	extrn	PATTY_PXR1	; xW1
	extrn	PATTY_PXR2	; xW2
	extrn	PATTY_STR	; stߐ register
;-----------------------------------------------------------------------------
;       C6270-2(7UP-2) port address define
;-----------------------------------------------------------------------------
	extrn	RG7UP2		;R/W select 7up2 register
	extrn	LO7UP2		;R/W low byte to 7up2
	extrn	HI7UP2		;R/W high byte to 7up2
;-----------------------------------------------------------------------------
;       C6260(TEKKANNON) port address define
;-----------------------------------------------------------------------------
	extrn	TEKKAN		;W/O tekkannonn display timing set
	extrn	LOTAD		;W/O low address register
	extrn	HITAD		;W/O high address register
	extrn	LOTDT		;R/W pallet low data register
	extrn	HITDT		;R/W pallet high data register
;-----------------------------------------------------------------------------
;       PSG port address define
;-----------------------------------------------------------------------------
	extrn	PSG_R0		;W/O select CHANEL 0-5		only one
	extrn	PSG_R1		;W/O main volum			only one
	extrn	PSG_R2		;W/O freq low			0-5 ch
	extrn	PSG_R3		;W/O freq high			0-5 ch
	extrn	PSG_R4		;W/O chanel volum		0-5 ch
	extrn	PSG_R5		;W/O left and right balans	0-5 ch
	extrn	PSG_R6		;W/O wave and DDA		0-5 ch
	extrn	PSG_R7		;W/O noise			4-5 ch
	extrn	PSG_R8		;W/O LFO frq		only one with 0-1
	extrn	PSG_R9		;W/O LFO control	only one with 0-1
;-----------------------------------------------------------------------------
;       TIMER port address define
;-----------------------------------------------------------------------------
	extrn	TIMREG		;R/W time counter set
	extrn	TIMCTR		;W/O time stop / start
;-----------------------------------------------------------------------------
;       JOYPAD port address define
;-----------------------------------------------------------------------------
	extrn	JOYIO		;R/W joystick i/o port
	extrn	KPORT		;R   read port 8 bit's
	extrn	OPORT		;w   write port 8 bit's
;-----------------------------------------------------------------------------
;       IRQ CONTROL port address define
;-----------------------------------------------------------------------------
	extrn	IRQDIS		;R/W IRQ mask
	extrn	IRQREG		;R/W IRQ str if write is irq clear
;-----------------------------------------------------------------------------
;       C6270(7UP) inside registers number define
;-----------------------------------------------------------------------------
MAWR		equ	0		;W/O vram wright address reg.
MARR		equ	1		;W/O vram read address reg.
VWR		equ	2		;W   vram data write reg.
VRR		equ	2		;R   vram dara read reg.
CR		equ	5		;W/O controll reg.
RCR		equ	6		;W/O raster counter reg.
BXR		equ	7		;W/O bg x scroll reg.
BYR		equ	8		;W/O bg y scroll reg.
MWR		equ	9		;W/O memory dot space setup.
HSR		equ	10		;W/O h-sync setup
HDR		equ	11		;W/O h-sync setup
VPR		equ	12		;W/O v-sync setup
VDR		equ	13		;W/O v-sync setup
VCR		equ	14		;W/O v-sync setup
DCR		equ	15		;W/O DMA control
SOUR		equ	16		;W/O DMA sou. address
DISR		equ	17		;W/O DMA dis. address
LENR		equ	18		;W/O DMA move counter
DVSSR		equ	19		;W/O SAT address setup
;-----------------------------------------------------------------------------
;       JOYPAD key constant define
;-----------------------------------------------------------------------------
JOYLEFT		equ	$80
JOYDOWN		equ	$40
JOYRIGHT	equ	$20
JOYUP		equ	$10
JOYSTART	equ	$08
JOYSELECT	equ	$04
JOYB		equ	$02
JOYA		equ	$01
;-----------------------------------------------------------------------------
;       BLOCK TRANS DEFINE
;-----------------------------------------------------------------------------
_tii		equ	$73
_tdd		equ	$c3
_tin		equ	$d3
_tia		equ	$e3
_tai		equ	$f3
_rts		equ	$60
;-----------------------------------------------------------------------------
;		VRAM to VRAM DMA Controls
;-----------------------------------------------------------------------------
SDMA_AUTO_ON	equ	%10000		; Auto SPR_DMA
VDMA_DES_INC	equ	%00000
VDMA_DES_DEC	equ	%01000
VDMA_SRC_INC	equ	%00000
VDMA_SRC_DEC	equ	%00100
VDMA_VINT_ON	equ	%00010		; 荞݋
SDMA_VINT_ON	equ	%00001		; XvCgcl`I荞݂nm
;-----------------------------------------------------------------------------
;	u荞ݎ̃Xe[^X`FbNp̃tO`
;-----------------------------------------------------------------------------
VDP_VBUSY	EQU	%100_0000
VDP_VSYNC	EQU	%010_0000
VDP_VMDMA	EQU	%001_0000
VDP_SPDMA	EQU	%000_1000
VDP_RSHIT	EQU	%000_0100
VDP_SPOVR	EQU	%000_0010
VDP_SPHIT	EQU	%000_0001
;-----------------------------------------------------------------------------
;	XvCgp̒`EKvɉĕς镔łB
;-----------------------------------------------------------------------------
ORGH	equ		32
ORGV	equ		64
;SATBUF	equ		$7f00
;-----------------------------------------------------------------------------
;	Rg[WX^̒lӖĂB
;-----------------------------------------------------------------------------
VDP_CR_BB	equ	%1000_0000
VDP_CR_SB	equ	%0100_0000
;-----------------------------------------------------------------------------
;	16MByte D-RAM Card port
;-----------------------------------------------------------------------------
	extrn	DR0,A0L,A0M,A0H,I0L,I0H,O0L,O0H,CMD0
	extrn	DR1,A1L,A1M,A1H,I1L,I1H,O1L,O1H,CMD1
	extrn	DR2,A2L,A2M,A2H,I2L,I2H,O2L,O2H,CMD2
	extrn	DR3,A3L,A3M,A3H,I3L,I3H,O3L,O3H,CMD3

DATA_MPR	=	$40		; f[^C[WłoNԍ

lda_DR0	macro
;	csl
	lda	DR0
;	csh
	endm

ldy_DR0	macro
;	csl
	ldy	DR0
;	csh
	endm

adc_DR0	macro
;	csl
	adc	DR0
;	csh
	endm

lda_DR1	macro
;	csl
	lda	DR1
;	csh
	endm

ldy_DR1	macro
;	csl
	ldy	DR1
;	csh
	endm

cmp_DR1	macro
;	csl
	cmp	DR1
;	csh
	endm

lda_DR0_notinc	macro
	stz	I0L
	lda	DR0
	inc	I0L
	endm
;-----------------------------------------------------------------------------
;       END OF FILE
;-----------------------------------------------------------------------------
